Bug 48516 - ZipArchive.Save attempts to set position and seek non-seekable streams
Summary: ZipArchive.Save attempts to set position and seek non-seekable streams
Status: RESOLVED FIXED
Alias: None
Product: Class Libraries
Classification: Mono
Component: General (show other bugs)
Version: 4.6.0 (C8)
Hardware: PC Linux
: --- normal
Target Milestone: Untriaged
Assignee: Bugzilla
URL:
Depends on:
Blocks:
 
Reported: 2016-12-01 11:57 UTC by peter
Modified: 2016-12-20 20:55 UTC (History)
2 users (show)

See Also:
Tags:
Is this bug a regression?: ---
Last known good build:


Attachments

Description peter 2016-12-01 11:57:26 UTC
Looking at https://github.com/mono/mono/blob/master/mcs/class/System.IO.Compression/ZipArchive.cs#L228 you can see that Save will always attempt to set Length and Position to 0 as part of a save. This happens regardless of the mode selected. So if your stream is non-seekable, you cannot use it to create a ziparchive  (without using and intermediate memorystream).

A similar problem existed in .NET Core, but has recently been fixed:
https://github.com/dotnet/corefx/issues/11497

The bug can be easily reproduced with the following:

using System;
using System.IO;
using System.IO.Compression;

namespace SeekeableStreamBug {
  public class NonSeekableMemoryStream: MemoryStream {
    public override bool CanSeek => false;

    public override long Position {
      get { throw new NotSupportedException(); }
      set { throw new NotSupportedException(); }
    }

    public override long Length {
      get { throw new NotSupportedException(); }
      set { throw new NotSupportedException(); }
    }
  }

  public class Program {
    public static void Main( string[] args ) {
      using ( ZipArchive archive = new ZipArchive( new NonSeekableMemoryStream(), ZipArchiveMode.Create, false ) ) {
        var entry = archive.CreateEntry( "foo" );
        using ( var es = entry.Open() ) {
          es.Write( new byte[] { 4, 2 }, 0, 2 );
        }
      }
    }
  }
}
Comment 1 Alexander Köplinger [MSFT] 2016-12-20 20:55:41 UTC
Fixed by https://github.com/mono/mono/pull/4118, thank you!

Notice (2018-05-21): bugzilla.xamarin.com will be switching to read-only mode on Thursday, 2018-05-25 22:00 UTC.

Please join us on Visual Studio Developer Community and GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs and copy them to the new locations as needed for follow-up. The See Also field on each Bugzilla bug will be updated with a link to its new location when applicable.

After Bugzilla is read-only, if you have new information to add for a bug that does not yet have a matching issue on Developer Community or GitHub, you can create a follow-up issue in the new location. Copy and paste the title and description from this bug, and then add your new details. You can get a pre-formatted version of the title and description here:

In special cases you might also want the comments:

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Note You need to log in before you can comment on or make changes to this bug.